<template>
  <div :id="vId" ref="vId" style="height: 100%;width: 100%;"></div>
</template>

<script>
import WebControl from '@/utils/jsWebControl'
import { log,encrypt } from '@/utils/utils'

export default {
  name: "WebVideo",
  props:{
    vId:{
      type: String,
      default: "playWnd"
    },
    cameraIndex:{
      type: String,
      default: ""
    },
  },
  data() {
    return {
      oWebControl: null,
      publicKey:'',
    }
  },
  watch: {

  },
  mounted() {

    var clientWidth = this.$refs.vId.clientWidth
    var clientHeight = this.$refs.vId.clientHeight
    log(clientWidth)
    log(clientHeight)
    var that = this
    that.oWebControl = new WebControl({
      szPluginContainer: this.vId,                       // 指定容器id
      iServicePortStart: 15900,                           // 指定起止端口号，建议使用该值
      iServicePortEnd: 15909,
      szClassId:"23BF3B0A-2C56-4D97-9C03-0CB103AA8F11",   // 用于IE10使用ActiveX的clsid
      cbConnectSuccess: function () {                     // 创建WebControl实例成功
        that.oWebControl.JS_StartService("window", {         // WebControl实例创建成功后需要启动服务
          dllPath: "./VideoPluginConnect.dll"         // 值"./VideoPluginConnect.dll"写死
        }).then(function () {
          that.oWebControl.JS_SetWindowControlCallback({   // 设置消息回调
            cbIntegrationCallBack: (oData)=>{
              log("数据返回")
              log(oData.responseMsg);
            }
          });

          that.oWebControl.JS_CreateWnd(that.vId, clientWidth, clientHeight).then(function () { //JS_CreateWnd创建视频播放窗口，宽高可设定
            that.getPublicKey();  // 创建播放实例成功后初始化
          });
        }, function () { // 启动插件服务失败
        });
      },cbConnectError: function () { // 创建WebControl实例失败
        that.oWebControl = null;
        if (that.oWebControl != null) {
          log("插件未启动，正在尝试启动，请稍候...");
          that.oWebControl.JS_WakeUp("VideoWebPlugin://"); // 程序未启动时执行error函数，采用wakeup来启动程序
        }
      },
      cbConnectClose: function (bNormalClose) {
        // 异常断开：bNormalClose = false
        // JS_Disconnect正常断开：bNormalClose = true
        console.log("cbConnectClose");
        that.oWebControl = null;
      }
    });

    window.onresize = function temp() {
      console.log("窗口变动了");
      if (that.oWebControl != null) {
        that.oWebControl.JS_Resize(clientWidth, clientHeight);
        that.setWndCover()
      }

    };
    window.addEventListener('scroll', this.windowScroll)

  },
  created() {
  },
  methods: {
    init(){
      var that = this
      ////////////////////////////////// 请自行修改以下变量值	////////////////////////////////////
      var appkey = "27164347";                           //综合安防管理平台提供的appkey，必填
      var secret = encrypt(that.publicKey,"hC534Ht6pUnjhyBYZIpw");   //综合安防管理平台提供的secret，必填
      var ip = "112.22.27.18";                           //综合安防管理平台IP地址，必填
      var playMode = 0;                                  //初始播放模式：0-预览，1-回放
      var port = 1443;                                    //综合安防管理平台端口，若启用HTTPS协议，默认443
      var snapDir = "D:\\SnapDir";                       //抓图存储路径
      var videoDir = "D:\\VideoDir";                     //紧急录像或录像剪辑存储路径
      var layout = "1x1";                                //playMode指定模式的布局
      var enableHTTPS = 1;                               //是否启用HTTPS协议与综合安防管理平台交互，这里总是填1
      var encryptedFields = 'secret';					   //加密字段，默认加密领域为secret
      var showToolbar = 0;                               //是否显示工具栏，0-不显示，非0-显示
      var showSmart = 0;                                 //是否显示智能信息（如配置运行侦测后画面上的线框），0-不显示，非0-显示
      var buttonIDs = "0,16,256,257,259,514,516,768";  //自定义工具条按钮
      ////////////////////////////////// 请自行修改以上变量值	////////////////////////////////////

      that.oWebControl.JS_RequestInterface({
        funcName: "init",
        argument: JSON.stringify({
          appkey: appkey,                            //API网关提供的appkey
          secret: secret,                            //API网关提供的secret
          ip: ip,                                    //API网关IP地址
          playMode: playMode,                        //播放模式（决定显示预览还是回放界面）
          port: port,                                //端口
          snapDir: snapDir,                          //抓图存储路径
          videoDir: videoDir,                        //紧急录像或录像剪辑存储路径
          layout: layout,                            //布局
          enableHTTPS: enableHTTPS,                  //是否启用HTTPS协议
          encryptedFields: encryptedFields,          //加密字段
          showToolbar: showToolbar,                  //是否显示工具栏
          showSmart: showSmart,                      //是否显示智能信息
          buttonIDs: buttonIDs                       //自定义工具条按钮
        })
      }).then(function (oData) {
        console.log(JSON.stringify(oData))
        // that.oWebControl.JS_Resize(clientWidth, 200);  // 初始化后resize一次，规避firefox下首次显示窗口后插件窗口未与DIV窗口重合问题
        var cameraIndexCode = that.cameraIndex;
        var streamMode = 1;                                     //主子码流标识：0-主码流，1-子码流
        var transMode = 1;                                      //传输协议：0-UDP，1-TCP
        var gpuMode = 0;                                        //是否启用GPU硬解，0-不启用，1-启用
        var wndId = 1;

        cameraIndexCode = cameraIndexCode.replace(/(^\s*)/g, "");
        cameraIndexCode = cameraIndexCode.replace(/(\s*$)/g, "");
        console.log(cameraIndexCode)

        let s = JSON.stringify({
          cameraIndexCode: cameraIndexCode,                //监控点编号
          streamMode: streamMode,                         //主子码流标识
          transMode: transMode,                           //传输协议
          gpuMode: gpuMode,                               //是否开启GPU硬解
          wndId:wndId                                     //可指定播放窗口
        })
        that.oWebControl.JS_RequestInterface({
          funcName: "startPreview",
          argument: s
        })
      }); // 创建播放实例成功后初始化

    },

    getPublicKey(){
      var that = this
      that.oWebControl.JS_RequestInterface({
        funcName: "getRSAPubKey",
        argument: JSON.stringify({
          keyLength: 1024
        })
      }).then(function (oData) {
        log(oData)
        if (oData.responseMsg.data) {
          let ss = "-----BEGIN PUBLIC KEY-----\n" +
            oData.responseMsg.data +
            "\n-----END PUBLIC KEY-----"
          that.publicKey = ss;
          console.log(that.publicKey);
          that.init();
        }
      })
    },
    gopreview(){


    },

    setWndCover() {
      let that = this
      // var iWidth = $(window).width();
      // var iHeight = $(window).height();
      // var oDivRect = $("#playWnd").get(0).getBoundingClientRect();
      var iWidth = that.$refs.vId.clientWidth
      var iHeight = that.$refs.vId.clientHeight
      var oDivRect=document.getElementById(`${that.vId}`).getBoundingClientRect();         // 获取元素

      console.log(oDivRect)

      var iCoverLeft = (oDivRect.left < 0) ? Math.abs(oDivRect.left): 0;
      var iCoverTop = (oDivRect.top < 0) ? Math.abs(oDivRect.top): 0;
      var iCoverRight = (oDivRect.right - iWidth > 0) ? Math.round(oDivRect.right - iWidth) : 0;
      var iCoverBottom = (oDivRect.bottom - iHeight > 0) ? Math.round(oDivRect.bottom - iHeight) : 0;

      iCoverLeft = (iCoverLeft > 1000) ? 1000 : iCoverLeft;
      iCoverTop = (iCoverTop > 600) ? 600 : iCoverTop;
      iCoverRight = (iCoverRight > 1000) ? 1000 : iCoverRight;
      iCoverBottom = (iCoverBottom > 600) ? 600 : iCoverBottom;

      that.oWebControl.JS_RepairPartWindow(0, 0, 1001, 600);    // 多1个像素点防止还原后边界缺失一个像素条
      if (iCoverLeft != 0) {
        that.oWebControl.JS_CuttingPartWindow(0, 0, iCoverLeft, 600);
      }
      if (iCoverTop != 0) {
          that.oWebControl.JS_CuttingPartWindow(0, 0, 1001, iCoverTop);    // 多剪掉一个像素条，防止出现剪掉一部分窗口后出现一个像素条
      }
      if (iCoverRight != 0) {
          that.oWebControl.JS_CuttingPartWindow(1000 - iCoverRight, 0, iCoverRight, 600);
      }
      if (iCoverBottom != 0) {
          that.oWebControl.JS_CuttingPartWindow(0, 600 - iCoverBottom, 1000, iCoverBottom);
      }
    }

  },
  destroyed() {
    this.oWebControl.JS_RequestInterface({
      funcName: "stopAllPreview"
    });
    if (this.oWebControl != null){
      this.oWebControl.JS_HideWnd();   // 先让窗口隐藏，规避可能的插件窗口滞后于浏览器消失问题
      this.oWebControl.JS_Disconnect().then(function(){  // 断开与插件服务连接成功
        },
        function() {  // 断开与插件服务连接失败
        });
    }
  }
}
</script>

<style lang="scss" scoped>


</style>
